% Helper method for retrieveing BGA data, provided by co-supervisors

function [t,y, u_insulin, t_ins, u_glucagon,t_gluc, u_meal, t_meal] = getBGAdata(xlsx, date_var)

 %%% Real Data
optss1 = detectImportOptions(xlsx); 
optss1 = setvartype(optss1, {'Data_and_Time'}, 'datetime'); % select the datetime format for the first column
optss1 = setvaropts(optss1,{'Data_and_Time'},'InputFormat','HH:mm:ss.SSS');
optss1.SelectedVariableNames = [1 2 3 4 5];
BGfinger_new=readtable(xlsx,optss1);

real_value_main=BGfinger_new.BGAGlucoseLevel;
real_value=real_value_main;
real_value(isnan(real_value_main))=[];

Time_real= BGfinger_new.Data_and_Time;
Time_real(isnan(real_value_main))=[];
t_real_noDate = Time_real+years(120)+days(date_var)-hours(2)-minutes(24);

% Insulin
insulin_main=BGfinger_new.InsulinBolus;
insulin=insulin_main;
insulin(insulin_main == 0)=[]; 

t_insulin= BGfinger_new.Data_and_Time;
t_insulin(insulin_main == 0)=[];
t_insulin_noDate = t_insulin+years(120)+days(date_var)-hours(2)-minutes(24);

% Glucagon
glucagon_main=BGfinger_new.GlucagonBolus;
glucagon=glucagon_main;
glucagon(glucagon_main==0)=[]; 

t_glucagon= BGfinger_new.Data_and_Time;
t_glucagon(glucagon_main==0)=[];
t_glucagon_noDate = t_glucagon+years(120)+days(date_var)-hours(2)-minutes(24);

% Glucose
glucose_main=BGfinger_new.GlucoseInfusion;
glucose=glucose_main;
glucose(isnan(glucose_main))=[]; 

t_glucose= BGfinger_new.Data_and_Time;
t_glucose(isnan(glucose_main))=[];
t_glucose_noDate = t_glucose+years(120)+days(date_var)-hours(2)-minutes(24);

%%% BGA data
t = t_real_noDate;
y = real_value;
u_insulin = insulin;
t_ins = t_insulin_noDate;
u_glucagon = glucagon;
t_gluc = t_glucagon_noDate;
u_meal = glucose;
t_meal = t_glucose_noDate;
end

